%modelling of children. Only the variable O_tj is calculated in excel 

filename_1 = 'Matlab_children.xlsx';
C_tj = xlsread(filename_1,'C_tj','B2:H43'); %Children in KG
O_tj =  xlsread(filename_1,'O_tj','B2:H19'); %KG hours = C_tj*AverageHrs/week
Total_Children_tj = xlsread(filename_1,'Total_Children_tj','B2:H43'); %Obtained from projections

%%model
Coverage_tj = zeros(42,7);
for t = 1:17
    for j = 1:7
        Coverage_tj(t,j) = C_tj(t,j)/Total_Children_tj(t,j);
        Demander_intensity_tj(t,j) = O_tj(t,j)/(C_tj(t,j)*42.5); %42,5 is the max hours/week
    end
end
%%future parameters are stabilizing at the 2015 levels
for t = 17:42
    for j = 1:7
        Coverage_tj(t,j) = Coverage_tj(17,j);
        Demander_intensity_tj(t,j) = Demander_intensity_tj(17,j);
        C_tj(t,j) = Total_Children_tj(t,j)*Coverage_tj(t,j);
    end
end

for t = 1:42
    for j= 1:7 
        if j < 3
            M_tj(t,j) = C_tj(t,j)*Demander_intensity_tj(t,j)/9.7;
            Asst_M_tj(t,j) = C_tj(t,j)*Demander_intensity_tj(t,j)/6;
            Area_TJ(t,j) = C_tj(t,j)*5.3;
           
        else
            M_tj(t,j) = C_tj(t,j)*Demander_intensity_tj(t,j)/16;
            Asst_M_tj(t,j) = C_tj(t,j)*Demander_intensity_tj(t,j)/6;
             Area_TJ(t,j) = C_tj(t,j)*4;
        end
   
    end
   M_t(t,1)= sum(M_tj(t,:));
   Asst_M_t(t) = sum(Asst_M_tj(t,:));
   Area_T(t)= sum(Area_TJ(t,:));
end
%%
filename = 'Matlab_teachers.xlsx';
Teachers_T = xlsread(filename,'Stock_T','B2:B17');
Back_Dist_TJ =xlsread(filename,'B_t','B2:D18');
Age_Dist_A= xlsread(filename,'A_a','D2:D52');
Attrition_A = xlsread(filename,'Attrition','B2:C52');
InflowAge_A = xlsread(filename,'InflowAge_A','B2:B52');
Gender_Dist_TS = xlsread(filename,'Gender_Dist','B2:C42');
Act_M_t = xlsread(filename,'Act_M_t','B2:B18');
TA_A = xlsread(filename,'TA_a','C2:C52');
%%
% %%baseline scenario where all people where working population is 24-74
for t = 1:16
    for j = 1:3
        Teachers_TJ(t,j) = Teachers_T(t)*Back_Dist_TJ(t,j);
    end
end

for t = 2:16
    Teachers_Change_T(t,1) = Teachers_T(t)-Teachers_T(t-1);
    for j= 1:3
    Teachers_Change_TJ(t,j)= Teachers_TJ(t,j) - Teachers_TJ(t-1,j); 
    end
end

for t = 1:16
    Teachers_intensity_t(t,1) = Act_M_t(t)/Teachers_T(t,:);
end

for t = 17:41
    Act_M_t(t) = M_t(t)*Act_M_t(16)/M_t(16); % Actual Man years  teacher intensity remains the same
    Teachers_intensity_t(t,1) = Act_M_t(16)/Teachers_T(16);
    Teachers_T(t) = Act_M_t(t)/Teachers_intensity_t(t);
    Teachers_Change_T(t,1) = Teachers_T(t)-Teachers_T(t-1);
end

%%
%%converting it to a time age matrix 
Teachers_TAJ = zeros(42,52,3);
    
for t=16:40
        for j = 1:3
            for a = 1:51
                Teachers_TAJ(16,a,j)= Teachers_TJ(16,j)*Age_Dist_A(a);
                if j==3
                Outflow_TAJ(t+1,a,j) = Teachers_TAJ(t,a,j)*Attrition_A(a,2);
                else
                Outflow_TAJ(t+1,a,j) = Teachers_TAJ(t,a,j)*Attrition_A(a,1);
                end
            end
        end 
        Outflow_T(t+1)=sum(sum(Outflow_TAJ(t+1,:,:)));
        Inflow_T(t+1) = Teachers_Change_T(t+1)+ Outflow_T(t+1); 
        for a = 1:51
            Inflow_TA(t+1,a) = Inflow_T(t+1)*InflowAge_A(a);
                for j=1:3
                if j==1
                    Teachers_TAJ(t+1,a+1,j) = Teachers_TAJ(t,a,j)+Inflow_TA(t+1,a)- Outflow_TAJ(t+1,a,j);
                else 
                    Teachers_TAJ(t+1,a+1,j) = Teachers_TAJ(t,a,j)-Outflow_TAJ(t+1,a,j);
                end
            end    
        end
end
Teach_TJ=squeeze(sum(Teachers_TAJ,2)); 
Test_Teachers_T = sum(Teach_TJ,2);
%%       
%%Compliling results
BarneB_TA = Teachers_TAJ(:,:,1);
RelevantB_TA = Teachers_TAJ(:,:,2);
OtherB_TA = Teachers_TAJ(:,:,3);
filename_3 = 'Matlab_assistants.xlsx';
Assistants_T = xlsread(filename_3,'Stock_T','B2:B18');
Asst_Back_Dist_TJ =xlsread(filename_3,'A_B_t','B2:D18');
Age_Dist_A= xlsread(filename_3,'A_a','D2:D52');
Attrition_A = xlsread(filename_3,'Attrition','B2:C52');
InflowAge_A = xlsread(filename_3,'InflowAge_A','B2:B52');
Gender_Dist_TS = xlsread(filename_3,'Gender_Dist','B2:C42');
Asst_Act_M_t = xlsread(filename_3,'Act_M_t','B2:B18');
%%
%preallocation 

%%
for t = 1:16
    for j = 1:3
        Assistants_TJ(t,j) = Assistants_T(t)*Asst_Back_Dist_TJ(t,j);
    end
end

for t = 2:16
    Assistants_Change_T(t) = Assistants_T(t)-Assistants_T(t-1);
    for j= 1:3
    Assistants_Change_TJ(t,j)= Assistants_TJ(t,j) - Assistants_TJ(t-1,j); 
    end
end

for t = 1:16
    Assistants_intensity_t(t,1) = Asst_Act_M_t(t)/Assistants_T(t,:);
end

for t = 17:42
    Asst_Act_M_t(t,1) = Asst_M_t(t)*Asst_Act_M_t(16)/Asst_M_t(16); % Actual Man years  teacher intensity remains the same
    Assistants_intensity_t(t,1) = Asst_Act_M_t(16)/Assistants_T(16);
    Assistants_T(t) = Asst_Act_M_t(t)/Assistants_intensity_t(t);
    Assistants_Change_T(t) = Assistants_T(t)-Assistants_T(t-1);
end

%%
%%converting it to a time age matrix 
%%data is first available only for the year 2013 using which model is
%%historically recreated and future projections are made
%model for the first year (2013-2014)
Asst_TAJ = zeros(42,52,3);


%%
for t=16:40
    for j = 1:3
        for a = 1:50
                Asst_TAJ(16,a,j)= Assistants_TJ(16,j)*Age_Dist_A(a);
                if j==3
                Asst_Outflow_TAJ(t+1,a,j) = Asst_TAJ(t,a,j)*Attrition_A(a,2);
                else
                Asst_Outflow_TAJ(t+1,a,j) = Asst_TAJ(t,a,j)*Attrition_A(a,1);
                end
        end
    end
    Asst_Outflow_T(t+1)=sum(sum(Asst_Outflow_TAJ(t+1,:,:)));
    Asst_Inflow_T(t+1) = Assistants_Change_T(t+1)+Asst_Outflow_T(t+1);
    for a = 1:50
        Asst_Inflow_TA(t+1,a)= Asst_Inflow_T(t+1)*InflowAge_A(a);
        for j=1:3
            if j==1
                Asst_TAJ(t+1,a+1,j)=Asst_TAJ(t,a,j)+Asst_Inflow_TA(t+1,a)-Asst_Outflow_TAJ(t+1,a,j);
            else
                Asst_TAJ(t+1,a+1,j) = Asst_TAJ(t,a,j)-Asst_Outflow_TAJ(t+1,a,j);
            end
        end
    end
end
Asst_TJ=squeeze(sum(Asst_TAJ,2)); 
Test_Asst_T = sum(Asst_TJ,2);
%%       
%%Compliling results
Asst_BarneB_TA = Asst_TAJ(:,:,1);
Asst_RelevantB_TA = Asst_TAJ(:,:,2);
Asst_OtherB_TA = Asst_TAJ(:,:,3);
